{ --------------------------------------------------------------- }
{                   File : REG.PAS                                }
{          Copyright (c) : 1988  Heinz Hagemeyer & TOOLBOX        }
{                Sprache : TURBO PASCAL 4.0  (oder 3.0)           }
{              Ein Programm zur Auswertung von Mewerten          }
{                   mit Hilfe von GRAPH.PAS                       }
{ --------------------------------------------------------------- }

PROGRAM Regression;

USES Crt;                 { Entferne diese Zeile bei TURBO 3.0 !  }

{ --           Einbinden der INCLUDE Dateien                   -- }

{$I RegDef.pas              Konstanten und Typendefinitionen      }
{$I RegUtil.pas             Ntzliche und notwendige Routinen     }
{$I Eingabe.pas             Eingabe der Mewerte                  }
{$I RegQuad.pas             Quadratische Regression               }
{$I Spline.pas              Interpolation mit kubischen Splines   }
{$I RobLinFi.pas            Lineare Regression mit Unterdrckung  }
{                           von Ausreiern von Peter Kurzweil     }
{$I RegLin.pas              Lineare Regression normal             }


BEGIN
     Eingabe ( Anzahl,x,y,
               Lin, RLin, Loga, RLoga, Pot, RPot, Expo, RExpo,
               Quad,Kub_Spline);

     Assign (Datei,DateiName);
     Rewrite (Datei);
     Punkte (Anzahl,x,y,Datei);

     IF Lin THEN
     IF NOT Lineare_Regression (LinF,1,Anzahl,x,y,Datei)
     THEN Fehler (1);

     IF RLin THEN
     IF NOT Lineare_Regression (RLinF,1,Anzahl,x,y,Datei)
     THEN Fehler (1);

     IF Loga THEN
     IF NOT Lineare_Regression (LogaF,1,Anzahl,x,y,Datei)
     THEN Fehler (4);

     IF RLoga THEN
     IF NOT Lineare_Regression (RLogaF,1,Anzahl,x,y,Datei)
     THEN Fehler (4);

     IF Pot THEN
     IF NOT Lineare_Regression (PotF,1,Anzahl,x,y,Datei)
     THEN Fehler (5);

     IF RPot THEN
     IF NOT Lineare_Regression (RPotF,1,Anzahl,x,y,Datei)
     THEN Fehler (5);

     IF Expo THEN
     IF NOT Lineare_Regression (ExpF,1,Anzahl,x,y,Datei)
     THEN Fehler (6);

     IF RExpo THEN
     IF NOT Lineare_Regression (RExpF,1,Anzahl,x,y,Datei)
     THEN Fehler (6);

     IF Quad THEN
     IF NOT Quadratische_Regression (1,Anzahl,x,y,Datei)
     THEN Fehler (2);

     IF Kub_Spline THEN
     IF NOT Spline_Interpolation (Anzahl,x,y,Datei)
     THEN Fehler (3);

     Close (Datei);
END.