{ --------------------------------------------------------------- }
{                   File : REGDEF.PAS (gehrt zu REG.PAS)         }
{          Copyright (c) : 1988  Heinz Hagemeyer & TOOLBOX        }
{                Sprache : TURBO PASCAL 4.0  (oder 3.0)           }
{              Ein Programm zur Auswertung von Mewerten          }
{                   mit Hilfe von GRAPH.PAS                       }
{ --------------------------------------------------------------- }

CONST Nmax  = 200 ;                  { max. Anzahl der Messpunkte }
      Spline_Max  = 40;
      Spline_Max1 = 41;
      Step  = 0.1;                   { Abstand von Punkt zu Punkt }
      DateiName = 'REG.DAT';

      LinF = 0;                      { Arten der mglichen "Lin." }
     LogaF = 1;                      { "normalen" Regression.     }
      PotF = 2;
      ExpF = 3;

     RLinF = 4;                      { Arten der mglichen "Lin." }
    RLogaF = 5;                      { Regression mit Ausreiern. }
     RPotF = 6;
     RExpF = 7;

TYPE Messwerte = ARRAY [1 .. Nmax] OF Real;
     Vector    = Messwerte     ;      { fr Procedure RobustLinFit }
     Index     = 0 .. Nmax     ;
     Zeile     = STRING [80]   ;
     Art       = LinF .. RExpF ;

VAR Anzahl           : Index     ;   { der Mewerte               }
    x,y              : Messwerte ;
    Datei            : Text      ;

    { Art der Auswertung, da mehrere Gleichzeitig ausgewhlt werden }
    { knnen, als Boolean definiert.                                }
    { Lineare Arten der Regression sind :                           }

    Lin,            { Lineare Funktion                              }
    RLin,           {    "      "   mit Unterdrckung der Ausreier }
    Loga,           { Logarithm. Funktion                           }
    RLoga,          {     "       "  "        "        "     "      }
    Pot,            { Potenzfunktion                                }
    RPot,           {      "         "        "        "     "      }
    Expo,           { e - Funktion                                  }
    RExpo,          {       "        "        "        "     "      }

    Quad,           { Quadratische Regression nur ohne Unterdrck.  }
    Kub_Spline      { Interpolation (!) mit kubischen Splines       }

           : Boolean   ;

{ --------------------------------------------------------------- }
{ --                 Ende von REGDEF.PAS                       -- }
